



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>AngularJS进阶(三十三)书海拾贝之简介AngularJS中使用factory和service的方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">AngularJS进阶(三十三)书海拾贝之简介AngularJS中使用factory和service的方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 03:37:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>简介AngularJS中使用factory和service的方法</h1>
<p>AngularJS支持使用服务的体系结构“关注点分离”的概念。服务是JavaScript函数，并负责只做一个特定的任务。这也使得他们成为维护和测试的单独实体。控制器，过滤器可以调用它们作为需求的基础。服务使用AngularJS的依赖注入机制注入正常。</p>
<p>AngularJS提供例如许多内在的服务，如：$http,&nbsp;$route,&nbsp;$window,&nbsp;$location等。每个服务负责例如一个特定的任务，$http是用来创建AJAX调用，以获得服务器的数据。$route用来定义路由信息等。内置的服务总是前缀$符号。</p>
<p>这里介绍两种方法来创建服务：工厂、服务</p>
<h2>使用工厂方法</h2>
<p>对于已经存在实例对象的服务，Factory优先，直接返回这个对象。如：在多个Controller之间共享传递数据；对$resource的请求资源的封装。</p>
<p>使用工厂方法，我们先定义一个工厂，然后分配方法给它。</p>
<pre class="prettyprint linenums">   var mainApp = angular.module("mainApp", []);
   mainApp.factory('MathService', function() {
     var factory = {};
     factory.multiply = function(a, b) {
      return a * b
     }
     return factory;
   }); </pre>
<h2>使用服务方法</h2>
<p>对于需要new创建的服务而言，则Service优先，Angular会自动new并创建这个对象实例。Service更容易组织一组相同业务逻辑的API,使得业务逻辑更加的内聚。</p>
<p>使用服务的方法，我们定义了一个服务，然后分配方法。还注入已经可用的服务。</p>
<pre class="prettyprint linenums">mainApp.service('CalcService', function(MathService){
  this.square = function(a) {
 return MathService.multiply(a,a);
 }
});</pre>
<h2>例子</h2>
<p>下面的例子将展示上述所有指令。</p>
<p>testAngularJS.html</p>
<pre class="prettyprint linenums">&lt;html&gt;
&lt;head&gt;
  &lt;title&gt;Angular JS Forms&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;h2&gt;AngularJS Sample Application&lt;/h2&gt;
  &lt;div ng-app="mainApp" ng-controller="CalcController"&gt;
   &lt;p&gt;Enter a number: &lt;input type="number" ng-model="number" /&gt;
   &lt;button ng-click="square()"&gt;X&lt;sup&gt;2&lt;/sup&gt;&lt;/button&gt;
   &lt;p&gt;Result: {{result}}&lt;/p&gt;
  &lt;/div&gt;
  &lt;script src="http://ajax.googleapis.com/ajax/libs/angularjs/1.2.15/angular.min.js"&gt;&lt;/script&gt;
  &lt;script&gt;
   var mainApp = angular.module("mainApp", []);
   mainApp.factory('MathService', function() {
     var factory = {};
     factory.multiply = function(a, b) {
      return a * b
     }
     return factory;
   });
    mainApp.service('CalcService', function(MathService){
      this.square = function(a) {
      return MathService.multiply(a,a);
     }
   });
    mainApp.controller('CalcController', function($scope, CalcService) {
      $scope.square = function() {
      $scope.result = CalcService.square($scope.number);
     }
   });
  &lt;/script&gt;
&lt;/body&gt;
&lt;/html&gt;</pre>
<h2>结果</h2>
<p>在Web浏览器打开textAngularJS.html。看到结果如下:</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160225193352792?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<h2>美文美图</h2>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160225193419234?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160817173649613?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160817173703383?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495xdrm8.html">jpa&plus;springdata</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q77vexq.html">Jquery Mobile开发以及Js对象动态绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxooz0q.html">来杯Caffe&mdash;&mdash;在ubuntu下安装Caffe框架并测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw012r9.html">Github Atom 1&period;12&period;0-beta3 发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p3pjzq.html">&lbrack;Android Studio&rsqb; &ast;&period;jar 与 &ast;&period;aar 的生成与&ast;&period;aar导入项目方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnyl538.html">【NOIP2009 T3】 最佳贸易 （双向SPFA）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4kvg39.html">js中的replace全局替换</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jvegg9.html">1032&colon; &lbrack;JSOI2007&rsqb;祖码Zuma</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1nvp59.html">采用ETL with RDBMS模式来实现ETL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdej50v9.html">调试时屏蔽JavaScript库代码 &ndash;Chrome DevTools Blackbox功能介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zn3dg9.html">SQL AlawaysOn 之一：安装域控制器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg2e0m8.html">VIM新手福利，配置向</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge2vjz8.html">ASP&period;NET Core 入门教程 10、ASP&period;NET Core 日志记录&lpar;NLog&rpar;入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me3320q.html">insert into select的实际用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jjp7jq.html">CentOS开启telnet服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2dpjx9.html">Comet OJ - Contest &num;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdwnm9.html">js jquery css 选择器总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyg0kjq.html">小程序图表wx-chart</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvx14l8.html">Heaven of Imaginary（PKUSC2018）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w4wp0q.html">【Python】yield</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1wjejq.html">Docker 列出镜像</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz7v7g8.html">Dynamics 365 Online 试用账号申请方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd57049.html">hiredis异步接口封装并导出到Lua</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj0pl19.html">AWS EC2 CentOS release 6&period;5 部署redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjel528.html">利用QrCode&period;Net生成二维码 asp&period;net mvc c&num;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpvxzjq.html">hadoop入门级总结一：HDFS</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j1n7o8.html">PGM：有向图模型：贝叶斯网络</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnje6mx8.html">pandas小记：pandas数据输入输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy13322q.html">Struts 2 之类型转换器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kxxwz9.html">Hive-ORC文件存储格式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
